#include "MQPlugin.h"
#include "MQBasePlugin.h"

class MergeMorph : public MQObjectPlugin
{
public:
	MergeMorph();
	~MergeMorph();

	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	virtual const char *GetPlugInName(void);
	virtual const char *EnumString(int index);
	virtual BOOL Execute(int index, MQDocument doc);

	std::string getNewMorphName(std::string &morph);

	BOOL main();
private:

	bool addMorph(cmq::CMQObject &newmorph, cmq::CMQObject &baseobj, cmq::CMQObject &morphobj, double weight);
	std::vector<cmq::CMQObject> getMorphlist();
	bool isMorphObject(const std::string &objname, const std::string &morphobjname);
	std::string getObjectMainName(const std::string &origname);
	bool existObject(const std::string &name);

	cmq::CMQDocument doc;
	cmq::CMQObject m_baseobj;
	cmq::CMQObject m_morphobj1;
	cmq::CMQObject m_morphobj2;
	double m_weight1;
	double m_weight2;
	std::wstring m_newmorphname;

	BOOL callDialog();

	friend MergeMorphWindow;
};

